import pybtex.database as bibtex

import itertools

characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
numbers = '0123456789'

# Generate all possible combinations of characters and numbers up to a certain length
max_length = 3  # You can change this to specify the maximum length of the IDs
combinations = itertools.product(characters + numbers, repeat=max_length)

# Convert each combination into a string and print them in lexicographic order
ascending_ids = [''.join(combination) for combination in combinations]
ascending_ids.sort()

keys = {}
file = open('main_ordering.bbl', 'r')

counter = 0
for line in file:
    if line.startswith('\\bibitem'):
        key = line.split('{')[1].split('}')[0]
        keys[key] = ascending_ids[counter]
    counter = counter + 1
# Load the .bib file
bib_data = bibtex.parse_file('refs.bib')
# Iterate through each entry in the .bib file
# for entry_key, entry in bib_data.entries.items():
#     print(entry_key)
#     # Check if the entry has a 'year' field
#     if 'year' in entry.fields:
#         year = entry.fields['year']
#         # # Check if the entry has a 'booktitle' field
#         # if 'booktitle' in entry.fields:
#         #     booktitle = entry.fields['booktitle']
#         #     # Append the year to the booktitle
#         #     entry.fields['booktitle'] = f"{booktitle} {year}"
            
#     else :
#         entry.fields['year'] = str(counter)
    
#     counter += 1

for entry_key, entry in bib_data.entries.items():
    print(entry_key)
    # Check if the entry has a 'year' field

    if 'year' in entry.fields:
        year = entry.fields['year']
        # Check if the entry has a 'booktitle' field
        if 'booktitle' in entry.fields:
            booktitle = entry.fields['booktitle']
            #check if booktitle contains a string with numbers and remove it
            if any(char.isdigit() for char in booktitle): 
                booktitle = ''.join([i for i in booktitle if not i.isdigit()])

            # Append the year to the booktitle
            entry.fields['booktitle'] = f"{booktitle} {year}"

        if 'journal' in entry.fields:
            journal = entry.fields['journal']
            # Append the year to the booktitle
            entry.fields['journal'] = f"{journal} {year}"

    if entry_key in keys:
        #remove the entry from the dictionary
        print(keys[entry_key])
        entry.fields['year'] = str(keys[entry_key])



# Save the modified .bib file
with open('updated_file.bib', 'w') as bib_file:
    bib_data.to_file(bib_file)